#include<stdio.h>
#include<stdlib.h>
#include<fcntl.h>
#include<sys/stat.h>
#include<time.h>
#include<vga.h>
#include<vgagl.h>
#include<vgamouse.h>
#include<sys/utsname.h>

#include "spexeso.h"


GraphicsContext physicalscreen;



struct pexeso  pex[SPRITE_C] ;
struct playboard board;
struct cpu_brain brain ;
struct menusetup menu ;
scorelist score[MAXSCORE] ;

int mouse_x , mouse_y , mouse_tl;
unsigned char mousemap[16][16] ;
unsigned char *old ;
int mpx , mpy ;
int oldx , oldy ;
unsigned char *font ;



/* char *getcpuname() ; */

int uncompres(int t )
{
int size , j , i , cn , l , c , of  ,b   ;
int bmpof[10] =  { 0 , 0 , 13627 , 26757 , 48684 , 57095 ,  77749 , 109789 , 142481 ,  170620 };
int bmpsize[10] = { 0 , 13627 , 13130 , 21927 , 8411 , 20654 , 32040 , 32692 , 28139 , 40782 };
unsigned char *bmp ;


size = 51744 ; 

bmp = malloc( size );

of = bmpof[t] ;
c = bmpof[t]  + bmpsize[t] ;


/* RLE encoding */

for( j = of , l = 0   ; j < c ; )
{
if( cbmp[j] >= 128 ) 
{
cn = cbmp[j] & 0x7f ;
for( i = 1 ; i <= cn ; i ++, l++ )  bmp[l] =  cbmp[j+1] ; 
j+=2 ;
}
else
{
for( i = 1 ; i <= cbmp[j] ; i ++ , l ++  ) bmp[l] =  cbmp[j+i];
j = j + i ;
}

}


for( c = 0 , of = 0  ; c < SPRITE_C ; c ++ , of += 1568 )
{ 
pex[c].x = 0 ; 
pex[c].y = 0 ;
pex[c].px =  SPRITE_X  ; 
pex[c].py =  SPRITE_Y  ; 


pex[c].p = malloc( SPRITE_X  * SPRITE_Y );


 for( i = 0 , j = 0  ;i < 1568 ; i ++ , j += 2 )
  {
   pex[c].p[j+0] = bmp[i+of] &0x0f ;
   pex[c].p[j+1] = bmp[i+of] /16 ;
  }


}


free( bmp );
return l;
}




int pexes( int x , int y , int px )
{
int x1 , x2 , y1 , y2 , c ;

x1 = 2+(x * 60) -1 ;
x2 = 2+(x * 60) +  SPRITE_X  +1 ;
y1 = 2+(y * 60) -1 ;
y2 = 2+(y * 60) + SPRITE_Y  + 1 ;

/* card */
if( (px < 64 ) && ( px > 0 )  )
{
 gl_putbox( 2 + x * 60 ,2 + y * 60 , pex[px].px , pex[px].py,  pex[px].p  ); 
 menubox( x1,  y1, x2 ,  y2 , 3 );
}

/* free space */
if( px == FREECARD ) 
{
 gl_fillbox( x1  , y1  , 59 , 59 , BACKGROUND  ); 
}

/* base card */
if( px == BASECARD )
{
 gl_putbox( 2 + x * 60 ,2 + y * 60 , pex[0].px , pex[0].py,  pex[0].p  );
 menubox( x1,  y1, x2 ,  y2 , 0 );
}


}



void menubox( int x1 , int y1 , int x2 , int y2 , int tl )
{
int co[] = { 15 , 8, 15 , 8 , 8, 15 , 8 , 15 , 6 , 6, 6 , 6 , 8 , 0 , 8 , 0 };
int l ;

l = tl * 4 ;

gl_line( x1 , y1 , x2 , y1 , co[l+0] );
gl_line( x1 , y2 , x2 , y2 , co[l+1] );
gl_line( x1 , y1 , x1 , y2 , co[l+2] );
gl_line( x2 , y1 , x2 , y2 , co[l+3] );

}


void  fontprint( int x , int y , int znak , int barva )
{
int i  , l , of , ff , xx , yy  ;


l = znak ;
of = l * 8 * 16 ;

for( l = 0 , yy = y ; l < 16 ; l++ , of += 8 , yy++ )
for( i = 0 , xx = x ; i < 8 ; i ++ , xx ++ )
if( font[of+i]  ) gl_setpixel( xx , yy ,   barva);
else gl_setpixel( xx , yy , BACKGROUND );
}

void textprint( int xx , int yy ,unsigned  char *p , int color)
{
int i, x , y , l  ;

l = strlen( p );
y = yy ;
x  =xx ;
for( i = 0  ; i < l  ; i ++ , x += FONT_X )
{
if( p[i] == '\n' ) { x = xx  - FONT_X ;  y = y + 16 ; }
else fontprint( x , y , p[i] , color );
}


}

void menuprint( int x , int y , char *p ,int col ,  int bx  )
{
int x1 , y1 , x2 , y2 , l ;

l = strlen( p );

menubox( x-1 , y -3 , x + l * FONT_X + 9 , y + FONT_Y + 3 , bx ); 
textprint( x +4 , y , p , col  ); 


}



int main( int argc , char *argv[] , char *env[] )
{
int h  , s , x , p , j,  j1x , j1y ,j2y, j2x , pm , y , tl , pl , l , st , jt , pr , i , mode = G640x480x256 , c  , of  , cl , px , py  , back , p1 , p2 , pp   ,k  , pc , sada , sd , vi ; 
unsigned char r , g , b , t , a  , tmp[80] ;
char *par[10] = { "none" , "alphabet" , "math" , "face" , "flag" , "road" , "city" , "safari" , "butterfly" , "vecernicek" } ;  
unsigned char *ppar[10] = { "none" , "alphabet" , "math's symbol" , "people's face" , "world's flag" , "road's mark" , "town's mark" , "ZOO animals" , "butterfly" , "vecernicek" } ;  
extern unsigned char *def[289] ;
struct user_name user[MAXPLAYERS] ;
struct utsname name ;
/*
char username[MAXPLAYERS][13] ;
int player = 0 , tg[MAXPLAYERS] , tb[MAXPLAYERS];
*/
int player = 0 , cpu = 0 ;


/* default */  sada = 9 ;                


 
for( i = 1 ; i < argc ; i ++ )
{
	if( argv[i][0] == '-' )
	{
	
	for( j = 1 ; ; j ++ )
	{
	if( argv[i][j] == 0 ){tmp[j-1] = 0 ; break ; }
	else tmp[j-1] = argv[i][j] ;
	}
	
	for( j = 1 ; j < 10 ; j ++ ) 
	 {
	 if(  strcmp( tmp , par[j] ) == 0 ) { sada = j  ; break ;} 
	 }
	 
         if(  strcmp( tmp , "linux" ) == 0 ) 
           {
            cpu  = 1 ;
           /* i ++ ; */
           if( i < argc -1) {sscanf( argv[i+1] ,  "%d" ,   &(brain.iq) ); i++;  }
           } 
        
	}
  else
       {
       /* pokud je jmeno delsi nez 12 tvrde to utni */
       strncpy( user[player].name  , argv[i] , 12 );
       user[player].name[13] = 0 ;
       user[player].cpu = 0 ;
       player ++ ;
        } 
}

/* GET Login name */

if( player == 0 )
{
 
for( i = 0 , j =0  ;  env[i][0] != 0  ; i ++ )
 {

j = strstr(  env[i] , "LOGNAME" ) ;

if( j ) 
  {
for( l = 0 ; env[i][l] != '='  ; l ++  ) ;
l++;
player = 1 ;
 for( k = 0 ;  ; k ++  )
  {
   user[0].name[k] = env[i][k+l] ;
   if( env[i][k+l]  == '\0' ) break ;
   }
   user[0].cpu = 0 ;
  break;
  }
 }

}

if( (player == 1) && ( cpu == 1 ) ) 
{
player  = 2 ;
/* jmeno  OS and cpu */
uname( &name );

sprintf( user[1].name , "%s %s",  name.sysname  ,   name.machine ); 
user[1].cpu = 1 ; 
/* default intel */
if(  brain.iq <= 0 )  brain.iq = 2 ;
printf("Intelligence of your %s is: %d\n" , user[1].name , brain.iq );
   
}

/* pokud je vice hracu nez 4 */
if( player > 4 ) player =4 ;
for( pl = 0 ; pl < player ; pl++ )printf("Get players%2d: %s\n" , pl +1 , user[pl].name );

/*********** Rozhoz noveho pexesa *******/
printf("Uncompressing image data: collection of %s\n" ,ppar[sada]  );  
uncompres( sada );

/**** rozhozeni karticek pexesa ****/
randompexeso();


/* read high score */
read_high_score(score);


/********* init font *********/

printf("init font: iso-8859-2 size 8x16\n"); 
init_font();
/********* init screen *********/

/* printf("init resolutions "); */
init_screen();
init_mouse() ; 
init_palet();

defkursor( 2 , 16 , 15  );  


/* for mouse kursor */

back = 7 ;
oldx = 600 ;
oldy = 460 ;
old = malloc( 16 * 16);

for( i = 0 ; i < 256 ; i ++ ) old[i] = BACKGROUND ;
gl_fillbox(0,0,WIDTH,HEIGHT, BACKGROUND );  
mouse_x = 600 ;
mouse_y = 460 ;
drawkursor();


/* pocatecni pocha */
for( y = 0 , i = 0 ;  y < 8 ; y ++ )
for( x = 0 ;  x < 8 ; x ++ , i ++ )pexes( x , y ,  BASECARD  ) ;

for( y = 0 , i = 0 ;  y < 8 ; y ++ )
for( x = 0 ;  x < 8 ; x ++ , i ++ )brain.take[x][y] = brain.pex[x][y] = 0 ;

/* brain.iq = 3 ; */

mouse_tl = 0 ;
for( pl = 0 ; pl < player ; pl++ ){ user[pl].tg = 0 ;  user[pl].tb = 0 ; }
menu.act = 0 ; pc = 0 ;
sd =( (sada-1) * 32);
st = ((player-1) * 72) ; 
tl = 1; 
pl = 0;
pm = 0;


for( ;; )
{
s = 0 ;
p = 0 ;

if( mouse_update() ){  p = 1 ; getmouse(); }

 getmenu();

 if( tl == 1 ) { tl = 0 ; mouse_tl = 1 ; }

if(  mouse_tl    ) printmenu(); 




/* kone Quit */
if( menu.act == 3 ) 
{
if( (player == 1 ) && ( user[0].tg > 0 )  ) 
{
recalc_high_score( user[0].name , user[0].tb , sada );
write_high_score(score); 
}
break ;
}

/* spoctni karticek  pexesa na desce  */

for( y = 0 , i = 0 , pp=0 ;  y < 8 ; y ++ )
for( x = 0 ;  x < 8 ; x ++ , i ++ )
{
if( board.pex[x][y] == 0    ) pp ++ ;
if( (cpu == 1) && ( board.take[x][y] == 1 ) )
  {
  brain.pex[x][y] = board.pex[x][y] ;
  brain.take[x][y] = 1 ;
  }
}

/* pokud uz neni dalsi pexeso */
if( pp == 64 ) break ;

if( ( ( mouse_tl > 0 ) && ( mouse_x < 480  ) &&  ( menu.act == 0 ) ) || ( user[pl].cpu == 1 )   )
{

px =( mouse_x - 4 ) / 59;
py =( mouse_y - 4 ) / 59;
jt = 0;



/* pocet kusu pexesa otocenych */
for( y = 0 , i = 0 , pp=0 ;  y < 8 ; y ++ )
for( x = 0 ;  x < 8 ; x ++ , i ++ )
{
if( board.take[x][y] == 1   ) pp ++ ;
}


/* otoceni nove karticky */
 
if( ( mouse_tl == MOUSE_LEFTBUTTON  ) &&( px >= 0) && ( px <  8 ) &&  ( py >= 0) && ( py <  8 )   &&  ( board.take[px][py] == 0 )  &&  ( board.pex[px][py] > 0 )  && ( pp <= 1 )  && ( user[pl].cpu == 0 ) )
{
 board.take[px][py] = 1 ;
 jt = board.pex[px][py] ;
}

/* pocitac duma */
vi = 0 ;
if( (user[pl].cpu == 1 ) && ( pp <=  1 ) ) 
{
jt = linux_brain( brain.iq ) ; 
vi = 2 ; 
}

/* zjisteni jestli jsou si pexesa rovny */

board.pex1 = 0;
board.pex2 = 0;
board.p1x = 0 ; board.p1y = 0 ;
board.p2x = 0 ; board.p2y = 0 ;

for( y = 0 , i = 0 , pp = 0 ;  y < 8 ; y ++ )
for( x = 0 ;  x < 8 ; x ++ , i ++ )
{
 if( board.take[x][y] == 1   )
   { pp ++ ;
    if( pp == 1 ) { board.pex1 = board.pex[x][y] ; board.p1x = x ; board.p1y = y ;}
    if( pp == 2 ) { board.pex2 = board.pex[x][y] ; board.p2x = x ; board.p2y = y ;}
   }
}

/* co delat kdyz jsou si pexesa stejna */
if( ( board.pex1 > 0 ) && ( board.pex2 > 0 ) && ( board.pex1 == board.pex2 ) )
{
board.take[board.p1x][board.p1y] = 0 ;
board.pex [board.p1x][board.p1y] = 0 ;
board.take[board.p2x][board.p2y] = 0 ;
board.pex [board.p2x][board.p2y] = 0 ;

board.pex1 = FREECARD ;
board.pex2 = FREECARD ; 

user[pl].tg ++ ;
pp = 0 ;
}


/* po druhe karticce se nerovnaji */
if( ( board.pex1 > 0 ) && ( board.pex2 > 0 ) && ( board.pex1 != board.pex2 ) && ( jt > 0 ) ) user[pl].tb ++ ;



/* zakryti pexesa */ 
if( ( (pp == 2 )  &&  ( mouse_tl == MOUSE_RIGHTBUTTON )  && ( user[pl].cpu == 0 ) ) || (  (pp == 2 )  &&  ( user[pl].cpu == 1 ) && ( vi == 0 ) ) )
{
/* stejne jsou znamy x , y  */

board.pex1 = BASECARD ;
board.pex2 = BASECARD ; 


for( y = 0 , i = 0   ;  y < 8 ; y ++ )
for( x = 0 ;  x < 8 ; x ++ , i ++ )
{
if( board.take[x][y] == 1   ) board.take[x][y] = 0 ;
/* zapomina */
if( (  brain.take[x][y] > 0 ) && ( user[pl].cpu == 1 )     )  brain.take[x][y]  ++ ;

}

/* next player */
pl ++ ;
if( pl >= player ) pl = 0 ;
}


/****** write *******/
gl_putbox( oldx , oldy , 16 , 16 , old );


/* popis pexesa */


if( board.pex1 )pexes(  board.p1x , board.p1y , board.pex1 );

if( board.pex2 )pexes(  board.p2x , board.p2y , board.pex2 );

 
if( jt )  
{

gl_fillbox( 485 , 417 , 150 , 58  , BACKGROUND );  

menubox( 484 , 410 , 636 , 476 , 1 );

textprint( 488 , 422 , def[sd+jt ]  , 0 );

}


for( pr = 0 ; pr < player ; pr ++ )
{
if( pr == pl )  j = 1 ;
else j =0 ;

menuprint( 486 , 340 - st + ( pr * 72 ) , user[pr].name , 3 + ( j * 6 ) , j );  

sprintf( tmp ,"OK  %3d" ,  user[pr].tg  );
menuprint( 486 , 374 -st + ( pr * 72 ) , tmp , 2 , 1 );

sprintf( tmp ,"BAD %3d" , user[pr].tb  );
menuprint( 570 , 374 - st + ( pr * 72 ), tmp , 4 , 1  );

}


oldx = mouse_x - mpx ;
oldy = mouse_y - mpy ;

gl_getbox( oldx , oldy   , 16 , 16 , old );

/* cekej , aby  to nebylo rychly */
if( (user[pl].cpu == 1) && ( vi > 0  )  ) sleep(1);

}
else
{

if(  menu.view == 1  ) about(); 

if(  menu.view == 2  ){ s = newgame();  }
if(  menu.view == 4  ) high_score();

}

if( menu.clear == 1 ) 
{
gl_fillbox( 484 , 110 , 156 , 300  , BACKGROUND );  
}


if( p ) {  drawkursor(); }

if( s )
{
sada = s;
menu.act = 0 ;
menu.clear = 0 ;
/*********** Rozhoz noveho pexesa *******/
uncompres( sada );

/**** rozhozeni karticek pexesa ****/
randompexeso();  

/* pocatecni pocha */
for( y = 0 , i = 0 ;  y < 8 ; y ++ )
for( x = 0 ;  x < 8 ; x ++ , i ++ )pexes( x , y ,  BASECARD  ) ;


mouse_tl = 0 ;
for( pl = 0 ; pl < player ; pl++ ){ user[pl].tg = 0 ; user[pl].tb = 0 ; }
menu.act = 0 ; pc = 0 ;
sd =( (sada-1) * 32);
st = ((player-1) * 72) ; 
tl = 1; 
pl = 0;

for( y = 0 , i = 0 ;  y < 8 ; y ++ )
for( x = 0 ;  x < 8 ; x ++ , i ++ )brain.take[x][y] = brain.pex[x][y] = 0 ;

brain.pexes = 0 ;

/****** write *******/
gl_putbox( oldx , oldy , 16 , 16 , old );

/* pocatecni pocha */
for( y = 0 , i = 0 ;  y < 8 ; y ++ )
for( x = 0 ;  x < 8 ; x ++ , i ++ )pexes( x , y ,  BASECARD  ) ;

/* clear */ 
gl_fillbox( 484 , 110 , 156 , 370  , BACKGROUND );  


oldx = mouse_x - mpx ;
oldy = mouse_y - mpy ;

gl_getbox( oldx , oldy   , 16 , 16 , old );


}

}


gl_freecontext(  &physicalscreen );

vga_setmode( TEXT );

mouse_close();

for( i = 0 ; i < SPRITE_C  ; i ++ )free( pex[i].p ); 
printf("Pexeso cardset: %s\n" , ppar[sada] );
printf("HIGH SCORE:\n");
/* setrideni podle nejlepsich hracu */
for( j = 32 ; j >= 0 ;j -- )
{
for( pl = 0 ; pl < player ; pl++ )
 {
   if( user[pl].tg == j )printf("|%2d | %-12s | OK  %3d | Bad %3d\n" ,pl + 1, user[pl].name , user[pl].tg , user[pl].tb );
 } 

}



/*
for( y = 0  ;  y < 8 ; y ++ )
{
for( x = 0 ;  x < 8 ; x ++  )
  {
   printf("|%2d|", brain.take[x][y] );
   }
   printf("\n--------------------------------\n");
}
printf("\n================================\n"); 
for( y = 0  ;  y < 8 ; y ++ )
{
for( x = 0 ;  x < 8 ; x ++  )
  {
   printf("|%2d|", brain.pex[x][y] );
   }
   printf("\n--------------------------------\n");
}
*/
return 0;
}


int linux_brain( int intel )
{
int x , y , i  , j , p ;
int x1 , x2 , y1 , y2 ; 
time_t tim ;



/* a ted druhou */

if( (brain.pexes  == board.pex[ brain.x2][ brain.y2]) && ( brain.pexes > 0  )  )
{
/* printf("Mam to (2) %d %d %d \n" , brain.x2 , brain.y2 ,  brain.pexes ); */
board.take[brain.x2][brain.y2] = 1 ;
j = board.pex[brain.x2][ brain.y2] ;
brain.pexes = 0 ;

return j ;
} 

brain.pexes = 0 ;

for( j = 1 ; j <= 32 ; j ++ )
{
p = 0 ;
for( y = 0  ;  y < 8 ; y ++ )
for( x = 0 ;  x < 8 ; x ++  )
  {
   if( (brain.pex[x][y] == j) && ( board.pex[x][y] > 0 )&& ( brain.take[x][y] <= intel ) )
   { 
    p ++ ;
    if( p == 1 ) { brain.x1 = x ;  brain.y1 = y; }
    if( p == 2 ) { brain.x2 = x ;  brain.y2 = y; } 
    }
  }

if( p == 2 ) { brain.pexes = brain.pex[ brain.x2][ brain.y2] ; break ; } 
}

/*  v  pohode neco je odkryto tak 1 karticku */
if( brain.pexes ) 
{
/* printf("Mam to (1) %d %d %d \n" , brain.x1 , brain.y1 ,  brain.pexes ); */
board.take[ brain.x1][ brain.y1] = 1 ;
j = board.pex[ brain.x1][ brain.y1] ;
return j ;
}

/* pokud neni zatim nic odkryto zkus to nahodne */

srandom( time(&tim) );

for( ; ; )
{
x =(int) (8.0*rand()/(RAND_MAX+1.0)); 
y =(int) (8.0*rand()/(RAND_MAX+1.0)); 
if( ( board.pex[x][y] > 0 ) && (board.take[x][y] == 0  )  ) 
 {
  board.take[x][y] = 1 ;
  j = board.pex[x][y];
  return j ;
 } 

}

}


int getmenu()
{
int i , lr , j , mn ; 
int men[16] = { 500 , 12 , 640 , 28 ,
                500 , 44 , 550 , 60 ,
                564 , 44 , 640 , 60 ,
                500 , 76 , 640 , 92 , };


mn = 0 ;
menu.view  = 0 ;
menu.clear = 0 ;

if( ( mouse_tl > 0 ) && ( mouse_x >= 480  ) && ( mouse_y < 180 ))
{
lr = 0 ;
for( j = 0 , i = 0  ;j < 4 ; j ++, i += 4 )
{ 
if( (mouse_x > men[i+0] ) && (mouse_y > men[i+1]) && (mouse_x < men[i+2]) &&( mouse_y < men[i+3] ) )
	{      
	if( mouse_tl == MOUSE_LEFTBUTTON ){ mn = j + 1; menu.act = j + 1 ; lr =1; menu.view = menu.act ; }
	if( mouse_tl == MOUSE_RIGHTBUTTON ){ mn = 0 ;menu.act = 0 ;lr = 2; menu.clear = 1 ; }
        break;
	}
}
}


/* if( lr == 2 ) { menu.act = 0 ; mn = 10 ;menu.clear = 1 ;}  */

if( ( mouse_tl > 0 ) && ( mouse_x < 480  ) && ( menu.act > 0 ) ) { menu.clear =1 ; menu.act = 0 ; mn = 10 ;} 


return mn ;
}



int printmenu()
{
int i , lr , j ; 
int men[16] = { 500 , 12 , 640 , 28 ,
                500 , 44 , 550 , 60 ,
                564 , 44 , 640 , 60 ,
                500 , 76 , 640 , 92 , };
                                                                
char *mname[] = { " CooL peXeso " , " New " , "Quit " , " High  Score " };                


gl_putbox( oldx , oldy , 16 , 16 , old );

for( i = 1  ;i <= 4 ;  i += 1 )
{
if( menu.act == i )
 {
 j = (i -1 )* 4 ;
 menuprint( men[j+0] , men[j+1] , mname[i-1] , 1 , 1 );
 }
else
 {
 j = (i -1 ) * 4 ;
 menuprint( men[j+0] , men[j+1] , mname[i-1] , 9 , 0 );
 }
} 

oldx = mouse_x - mpx ;
oldy = mouse_y - mpy ;
gl_getbox( oldx , oldy , 16 , 16 , old );



}

int randompexeso()
{
int x , y , i  , j , p ;
time_t tim ;
for( y = 0 ;  y < 8 ; y ++ )
for( x = 0 ;  x < 8 ; x ++ )board.take[x][y] = 0 ;

srandom( time(&tim) );


for( y = 0 , i = 0 ;  y < 8 ; y ++ )
for( x = 0 ;  x < 8 ; x ++ , i ++ )board.pex[x][y] = 0 ;


for( p = 1; p <= 64  ; )
{
x =(int) (8.0*rand()/(RAND_MAX+1.0)); 
y =(int) (8.0*rand()/(RAND_MAX+1.0)); 
if( board.pex[x][y] == 0  ) 
 {
  if( p > 32 ) j = p - 32 ;
  else j = p;  
  board.pex[x][y] = j ;
  p ++ ;
 } 

}


}


void read_high_score(scorelist *scores) 
{
	FILE *scorefile ;
	int i, j;
	scorefile = fopen (SCORE_FILE, "r");
	
	if (scorefile)
		for (i=0; i<10; i++) {
			for (j=0; j<12; j++)
			scores[i].name[j] = fgetc(scorefile);
			scores[i].name[13]=0;
			fscanf (scorefile, "%d%d\n", &(scores[i].sada),	&(scores[i].point));
		}
	else {
		for (i=0; i<10; i++) {
			strcpy(scores[i].name, "None");
			scores[i].sada = 0 ;
			scores[i].point = 0;
		}
	}
	fclose(scorefile);
}

void write_high_score(scorelist *scores)
 {
	int i, j;
	FILE *scorefile = fopen (SCORE_FILE, "w");
	if (!scorefile) {
		fclose(scorefile);
		printf("Open file % error\n" , SCORE_FILE);
		return;
	}
	for (i=0; i<10; i++) {
		for (j=0; j<strlen(scores[i].name); j++)
			fputc(scores[i].name[j], scorefile);
		for (j=strlen(scores[i].name); j<12; j++)
			fputc(' ', scorefile);
		fflush(scorefile);
		fprintf (scorefile, " %d %d\n", scores[i].sada, scores[i].point );
	}
	fclose(scorefile);
}



void recalc_high_score (char *name , int tb, int sd  )
 {
	int i, j;
	for (i=9; i>=0; i--)
		if ( (score[i].point < tb) && ( score[i].point > 0 ) ) break;
	if (i==9) return;
	for (j=8; j>i; j--) {
		strcpy (score[j+1].name, score[j].name);
		score[j+1].sada = score[j].sada;
		score[j+1].point = score[j].point;
	}
	i++;
	strcpy (score[i].name, name);
	score[i].sada  = sd;
	score[i].point = tb;
}



int about()
{
char *cool= "    CooL peXeso\nOrginal programing\n   for  Linux\n   Petr Blaha\npet@penguin.vscht.cz\n  blahap@vscht.cz\n    Graphics\n  Petr & Pavel\n     Matula\n  pam@fi.muni.cz\n  pem@fi.muni.cz\nPexeso  WEB  page\n  http://penguin.\n   vscht.cz/~pet/\n   spexeso.html" ;

gl_fillbox( 484 , 110 , 156 , 300  , BACKGROUND );  

menubox( 480 , 140 , 639 , 394 , 1 );

textprint( 482 , 148 , cool  , 2 );

}

int high_score()
{
int j , t;
char tmp[32] ;

gl_fillbox( 484 , 110 , 156 , 300  , BACKGROUND );

for( j = 0 ; score[j].point > 0 ; j ++ )
{

sprintf(tmp, "%d. " , j +1 );
textprint( 488 , 148 + j * 16 , tmp , 0 );

sprintf( tmp ,"%-10s " , score[j].name , score[j].point  );
textprint( 488 + FONT_X * 3 , 148 +  j * 16 , tmp , 12 );

sprintf( tmp ,"%3d" , score[j].point  );
textprint( 488 + FONT_X * 13 , 148 +  j * 16 , tmp , 14 );


}


/* pokud existuje */ 
if( j > 0 ) menubox( 484 , 136 , 636 , 136 +  ( (j+1) * 16 ) , 1 ) ; 
 

}

int newgame()
{
int x , y , j , new  , p , ex ;
int x1 , y1 , x2 , y2 ; 

new = 0 ;
ex =  0;
gl_fillbox( 484 , 110 , 156 , 300  , BACKGROUND );  

printnewgamemenu( new );


for( ;; )
{
p = 0;
if( mouse_update() ){  p = 1 ; getmouse(); }

for( j = 0 ; j < 9 ; j ++ )
{
x1 = 486 ;
x2 = 632 ;
y1 = 124 + j * 32 ;
y2 = 148 + j * 32 ;

if( (mouse_tl == MOUSE_LEFTBUTTON ) && ( mouse_x > x1 ) && ( mouse_x < x2 ) && ( mouse_y > y1 ) && ( mouse_y < y2 ) ) new = j +1 ;

}

if( mouse_tl == MOUSE_RIGHTBUTTON ) break ; 
if( (mouse_tl> 0 ) && ( mouse_x < 480 ) )break ;
if( new  ){ex = 1 ;  break ; }

if( p )drawkursor();
 }

if( ex ) printnewgamemenu( new );
else{ menu.act = 0 ; 
/****** write *******/
gl_putbox( oldx , oldy , 16 , 16 , old );
gl_fillbox( 484 , 110 , 156 , 300  , BACKGROUND );  
oldx = mouse_x - mpx ;
oldy = mouse_y - mpy ;

gl_getbox( oldx , oldy   , 16 , 16 , old );

  }

return new ;
}

printnewgamemenu( int n )
{
int j ;
unsigned char *ppar[10] = { "none" , "alphabet" , "math's symbol" , "people's face" , "world's flag" , "road's mark" , "town's mark" , "ZOO animals" , "butterfly" , "veernek" } ;  

/****** write *******/
gl_putbox( oldx , oldy , 16 , 16 , old );

for( j = 0 ; j < 9 ; j ++ )
{

if( j +1 == n ) menuprint( 500 , 126 + j * 32 , ppar[j+1] , 6 , 1 );
else menuprint( 500 , 126 + j * 32 , ppar[j+1] , 14 , 0  );

}

oldx = mouse_x - mpx ;
oldy = mouse_y - mpy ;

gl_getbox( oldx , oldy   , 16 , 16 , old );



}


/* init the SVGA screen */

void init_screen(void)
{
/* GraphicsContext physicalscreen; */
int VGAMODE = G640x480x256;
/* void *font; */

vga_init();

if (!vga_hasmode(VGAMODE))
  {
  fprintf(stderr, "Mode not available.\n");
  exit(-1);
  }
 else printf("inicializing resolutions: G640x480x256\n");
vga_setmode(VGAMODE);
gl_setcontextvga(VGAMODE);      /* Physical screen context. */
gl_getcontext(&physicalscreen);

gl_enableclipping();



}

void init_mouse()
{
vga_setmousesupport(1);
if ( mouse_init( "/dev/mouse", /* MOUSE_MICROSOFT */ vga_getmousetype()  , MOUSE_DEFAULTSAMPLERATE) )
  {
  fprintf(stderr, "Could not initialize mouse.\n");
  exit(-1);
  }
  else printf("Inicializing mouse: \"/dev/mouse\"\n");
mouse_setdefaulteventhandler();
mouse_setposition(WIDTH/2,HEIGHT/2);
mouse_setxrange(0,WIDTH-1);
mouse_setyrange(0,HEIGHT-1);
}


void init_palet()
{
int i , j ;
int rgbpal[48] = {0, 0, 0,0, 0,42,0, 42, 0,0, 42, 42,60, 48, 40,63, 42, 0,42, 21, 0,42, 42, 42,21, 21, 21,21, 21, 63,21, 63, 21,21, 63, 63,63, 21, 21,42, 0 , 42,63, 63, 21,63, 63, 63 };

for( i = 0 , j = 0  ; i < 16 ; i ++ , j += 3 ) gl_setpalettecolor( i , rgbpal[j+0] , rgbpal[j+1] ,rgbpal[j+2]  );
}


void  defkursor( int type , int mc  , int bg )
{
unsigned int mmo  , k  , mmk , o  , q ;
int i , x , y , d = 0 , l , j ;
unsigned int mk[64] = { 0x0180,0x0180,0x0180,0x0180,0x0180,0x0180,0x0180,0xffff,0xffff,0x0180,0x0180,0x0180,0x0180,0x0180,0x0180,0x0180, 
/*			0x0000,0x7000,0x7a00,0x7f80,0x3fa0,0x0400,0x0200,0x0100,0,0,0,0,0,0,0,0, */
                        0x0000,0x7000,0x7c00,0x7f80,0x3fc0, 0x3e00,0x1f00, 0x1b80, 0x19c0, 0x08e0, 0x0070, 0x0038, 0x01c, 0x000e, 0x0004, 0x0000 , 
			0x0060, 0x0060 , 0x0060 ,  0x0060, 0x1b60, 0xdb70, 0xdb73 , 0xfff3, 0xfff3,  0xfff7, 0xffff, 0xfffe, 0x7ff8, 0x7ff0, 0x7fe0, 0x7fe0, 	
			0x0300, 0x0300 , 0x0300 ,  0x0300, 0x1b60, 0xdb60, 0xdb66 , 0xffe6, 0xffe6,  0xfff6, 0xfffe, 0xfffe, 0x7ffc, 0x7ff8, 0x7ff0, 0x7fe0};


unsigned int mo[64] = { 0xfe7f,0xfe7f,0xfe7f,0xfe7f,0xfe7f,0xfe7f,0xfe7f,0x0,0x0,0xfe7f,0xfe7f,0xfe7f,0xfe7f,0xfe7f,0xfe7f,0xfe7f,
/*			0x03ff,0x03ff,0x07ff,0x07ff,0x03ff,0x31ff,0xf8ff,0xfcff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff, */
                         0x1fff,0x73ff,0x7c7f,0xffbf,0x9fff, 0x9e7f,0xdf7f, 0xdbbf, 0xd9df, 0xeeef, 0xff77, 0xffbb, 0xffdd, 0xffee, 0xfff5, 0xfffb ,
/*                        0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,  */
			0xff8f, 0xff8f , 0xff8f , 0xc00f , 0x0007, 0x0007, 0x0004 , 0x0004 , 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0007, 0x000f,0x000f ,
			0xfc7f, 0xfc7f , 0xfc7f , 0xc00f , 0x000f, 0x000f, 0x0008 , 0x0000 , 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0003, 0x0007,0x000f};
int xy[8] = { 7 , 8 , 1 , 1, 10 , 0 , 8 , 0 }; 

for( y = 0  ; y < 16 ; y ++ )
for( x = 0  ; x < 16 ; x ++ ) mousemap[x][y] = 0 ;




if( type > 0 )
{
l = type - 1 ;
j = l * 2 ;
mpx = xy[j] ;
mpy = xy[j+1] ;
j = l * 16 ;


for( i = 0 , y = 0 ; i < 16 ; i ++ ,  y ++ )
 {
 mmo =  mo[j +i];
 mmk =  mk[j +i];
  for( k  = 0x8000L , x = 0 ; k >= 1 ; k  = k / 2   , x ++ )
   {
   o = k &  mmk ;
   q = k &  mmo ;

if(  o == 0 ) 
{
if(  q    )  mousemap[x][y] = 0 ;
else  mousemap[x][y] = bg  ;
}
else mousemap[x][y] = mc ;

   } 

 }

}

}

void drawkursor()
{
int  x , y , a , b  ;
/* obnoveni stareho */
gl_putbox( oldx , oldy , 16 , 16 , old );

oldx = mouse_x - mpx ;
oldy = mouse_y - mpy ;

gl_getbox( oldx , oldy , 16 , 16 , old );

for( y = mouse_y - mpy  , a = 0  ; a <  16 ; y ++ , a ++  )
for( x = mouse_x - mpx , b = 0 ;  b < 16 ; x ++ , b ++  )
{
if( mousemap[b][a] )gl_setpixel(  x ,   y , mousemap[b][a] );
}


}


void getmouse()
{


mouse_x  = mouse_getx();
mouse_y  = mouse_gety();
mouse_tl =  mouse_getbutton();

}

int until_getmouse()
{
int t ;

for( ;; )
{
t = mouse_getbutton();
if( t == MOUSE_LEFTBUTTON ) break ;
}

return t ;
}

/*** END mouse function ********/

/* font funkce */

void init_font()
{
int i , h ;
int  l , of , znak ;
int off , sof , ff;
unsigned char z[16] , p[128] , a , b , c;
extern unsigned char teckofont[4096]  ; 

l  = 8 * 16 * 256 ;


font = malloc( l );

for( i = 0 ; i < l ; i ++ )font[i] = 0 ;

for( znak = 0 , ff = 0  ; znak < 256 ; znak ++ , ff += 128 )
{
off = znak * 16 ;

for( i = 0 ; i < 128 ; i ++ )p[i] = 0;


for( i = 0 ; i < 16 ; i ++ ) z[i] = teckofont[off+i];

for( l = 0 , of = 0  ; l< 16 ; l++ , of += 8)
{
a = z[l] ;
if( z != 0 )
 {
     b = 128 ;
     for(  i = 0 ;  i< 8 ; i ++ )
       {
	c = b & a ;
	if( c == b ) p[of+i] = 9 ;
	b = b / 2;
       }

 }
 else for( i = 0 ; i < 8 ; i ++ ) p[of+i] = 0 ;

}

for( l = 0   ; l< 128 ; l++ ) font[ff+l] = p[l] ;

}

/* gl_expandfont(8, 16 , 255 , gl_font8x8, fnt ); */

/* gl_setfontcolors(  7 , 15 ); */

gl_setfont( 8, 16 , font);

gl_setwritemode( WRITEMODE_MASKED  | FONT_EXPANDED );



}

